unit Shlwapi;

{-------------------------------------------------------------------------------
  Shlwapi.pas
  Shell Light Weight Utility APIs
  2003 (c) manison
-------------------------------------------------------------------------------}

interface

uses Windows, ShellAPI, Graphics, ActiveX;

const
  shlwapidll = 'shlwapi.dll';
  kernel32 = 'kernel32.dll';

type
  PPointer = ^Pointer;
  PPAnsiChar = ^PAnsiChar;

function StrChrA(lpStart: LPCSTR; wMatch: WORD): LPSTR; stdcall; external shlwapidll name 'StrChrA';
function StrChrW(lpStart: LPCWSTR; wMatch: WCHAR): LPWSTR; stdcall; external shlwapidll name 'StrChrW';
function StrChr(lpStart: LPCSTR; wMatch: WORD): LPSTR; stdcall; external shlwapidll name 'StrChrA';

function StrChrIA(lpStart: LPCSTR; wMatch: WORD): LPSTR; stdcall; external shlwapidll name 'StrChrIA';
function StrChrIW(lpStart: LPCWSTR; wMatch: WCHAR): LPWSTR; stdcall; external shlwapidll name 'StrChrIW';
function StrChrI(lpStart: LPCSTR; wMatch: WORD): LPSTR; stdcall; external shlwapidll name 'StrChrIA';

function StrCmpNA(lpStr1: LPCSTR; lpStr2: LPCSTR; nChar: Integer): Integer; stdcall; external shlwapidll name 'StrCmpNA';
function StrCmpNW(lpStr1: LPCWSTR; lpStr2: LPCWSTR; nChar: Integer): Integer; stdcall; external shlwapidll name 'StrCmpNW';
function StrCmpN(lpStr1: LPCSTR; lpStr2: LPCSTR; nChar: Integer): Integer; stdcall; external shlwapidll name 'StrCmpNA';

function StrCmpNIA(lpStr1: LPCSTR; lpStr2: LPCSTR; nChar: Integer): Integer; stdcall; external shlwapidll name 'StrCmpNIA';
function StrCmpNIW(lpStr1: LPCWSTR; lpStr2: LPCWSTR; nChar: Integer): Integer; stdcall; external shlwapidll name 'StrCmpNIW';
function StrCmpNI(lpStr1: LPCSTR; lpStr2: LPCSTR; nChar: Integer): Integer; stdcall; external shlwapidll name 'StrCmpNIA';

function StrCSpnA(lpStr: LPCSTR; lpSet: LPCSTR): Integer; stdcall; external shlwapidll name 'StrCSpnA';
function StrCSpnW(lpStr: LPCWSTR; lpSet: LPCWSTR): Integer; stdcall; external shlwapidll name 'StrCSpnW';
function StrCSpn(lpStr: LPCSTR; lpSet: LPCSTR): Integer; stdcall; external shlwapidll name 'StrCSpnA';

function StrCSpnIA(lpStr: LPCSTR; lpSet: LPCSTR): Integer; stdcall; external shlwapidll name 'StrCSpnIA';
function StrCSpnIW(lpStr: LPCWSTR; lpSet: LPCWSTR): Integer; stdcall; external shlwapidll name 'StrCSpnIW';
function StrCSpnI(lpStr: LPCSTR; lpSet: LPCSTR): Integer; stdcall; external shlwapidll name 'StrCSpnIA';

function StrDupA(lpSrch: LPCSTR): LPSTR; stdcall; external shlwapidll name 'StrDupA';
function StrDupW(lpSrch: LPCWSTR): LPWSTR; stdcall; external shlwapidll name 'StrDupW';
function StrDup(lpSrch: LPCSTR): LPSTR; stdcall; external shlwapidll name 'StrDupA';

function StrFormatByteSizeA(dw: DWORD; szBuf: LPSTR; uiBufSize: UINT): LPSTR; stdcall; external shlwapidll name 'StrFormatByteSizeA';
function StrFormatByteSize(dw: DWORD; szBuf: LPSTR; uiBufSize: UINT): LPSTR; stdcall; external shlwapidll name 'StrFormatByteSizeA';

function StrFormatByteSize64A(qdw: LONGLONG; szBuf: LPSTR; uiBufSize: UINT): LPSTR; stdcall; external shlwapidll name 'StrFormatByteSize64A';

function StrFormatByteSizeW(qdw: LONGLONG; szBuf: LPWSTR; uiBufSize: UINT): LPWSTR; stdcall; external shlwapidll name 'StrFormatByteSizeW';

function StrFormatKBSizeW(qdw: LONGLONG; szBuf: LPWSTR; uiBufSize: UINT): LPWSTR; stdcall; external shlwapidll name 'StrFormatKBSizeW';
function StrFormatKBSizeA(qdw: LONGLONG; szBuf: LPSTR; uiBufSize: UINT): LPSTR; stdcall; external shlwapidll name 'StrFormatKBSizeA';
function StrFormatKBSize(qdw: LONGLONG; szBuf: LPSTR; uiBufSize: UINT): LPSTR; stdcall; external shlwapidll name 'StrFormatKBSizeA';

function StrFromTimeIntervalA(pszOut: LPSTR; cchMax: UINT; dwTimeMS: DWORD; digits: Integer): Integer; stdcall; external shlwapidll name 'StrFromTimeIntervalA';
function StrFromTimeIntervalW(pszOut: LPWSTR; cchMax: UINT; dwTimeMS: DWORD; digits: Integer): Integer; stdcall; external shlwapidll name 'StrFromTimeIntervalW';
function StrFromTimeInterval(pszOut: LPSTR; cchMax: UINT; dwTimeMS: DWORD; digits: Integer): Integer; stdcall; external shlwapidll name 'StrFromTimeIntervalA';

function StrIsIntlEqualA(fCaseSens: BOOL; lpString1: LPCSTR; lpString2: LPCSTR; nChar: Integer): BOOL; stdcall; external shlwapidll name 'StrIsIntlEqualA';
function StrIsIntlEqualW(fCaseSens: BOOL; lpString1: LPCWSTR; lpString2: LPCWSTR; nChar: Integer): BOOL; stdcall; external shlwapidll name 'StrIsIntlEqualW';
function StrIsIntlEqual(fCaseSens: BOOL; lpString1: LPCSTR; lpString2: LPCSTR; nChar: Integer): BOOL; stdcall; external shlwapidll name 'StrIsIntlEqualA';

function StrNCatA(psz1: LPSTR; psz2: LPCSTR; cchMax: Integer): LPSTR; stdcall; external shlwapidll name 'StrNCatA';
function StrNCatW(psz1: LPWSTR; psz2: LPCWSTR; cchMax: Integer): LPWSTR; stdcall; external shlwapidll name 'StrNCatW';
function StrNCat(psz1: LPSTR; psz2: LPCSTR; cchMax: Integer): LPSTR; stdcall; external shlwapidll name 'StrNCatA';

function StrPBrkA(psz: LPCSTR; pszSet: LPCSTR): LPSTR; stdcall; external shlwapidll name 'StrPBrkA';
function StrPBrkW(psz: LPCWSTR; pszSet: LPCWSTR): LPWSTR; stdcall; external shlwapidll name 'StrPBrkW';
function StrPBrk(psz: LPCSTR; pszSet: LPCSTR): LPSTR; stdcall; external shlwapidll name 'StrPBrkA';

function StrRChrA(lpStart: LPCSTR; lpEnd: LPCSTR; wMatch:WORD): LPSTR; stdcall; external shlwapidll name 'StrRChrA';
function StrRChrW(lpStart: LPCWSTR; lpEnd: LPCWSTR; wMatch:WCHAR): LPWSTR; stdcall; external shlwapidll name 'StrRChrW';
function StrRChr(lpStart: LPCSTR; lpEnd: LPCSTR; wMatch:WORD): LPSTR; stdcall; external shlwapidll name 'StrRChrA';

function StrRChrIA(lpStart: LPCSTR; lpEnd: LPCSTR; wMatch:WORD): LPSTR; stdcall; external shlwapidll name 'StrRChrIA';
function StrRChrIW(lpStart: LPCWSTR; lpEnd: LPCWSTR; wMatch:WCHAR): LPWSTR; stdcall; external shlwapidll name 'StrRChrIW';
function StrRChrI(lpStart: LPCSTR; lpEnd: LPCSTR; wMatch:WORD): LPSTR; stdcall; external shlwapidll name 'StrRChrIA';

function StrRStrIA(lpSource: LPCSTR; lpLast: LPCSTR; lpSrch: LPCSTR): LPSTR; stdcall; external shlwapidll name 'StrRStrIA';
function StrRStrIW(lpSource: LPCWSTR; lpLast: LPCWSTR; lpSrch: LPCWSTR): LPWSTR; stdcall; external shlwapidll name 'StrRStrIW';
function StrRStrI(lpSource: LPCSTR; lpLast: LPCSTR; lpSrch: LPCSTR): LPSTR; stdcall; external shlwapidll name 'StrRStrIA';

function StrSpnA(psz: LPCSTR; pszSet: LPCSTR): Integer; stdcall; external shlwapidll name 'StrSpnA';
function StrSpnW(psz: LPCWSTR; pszSet: LPCWSTR): Integer; stdcall; external shlwapidll name 'StrSpnW';
function StrSpn(psz: LPCSTR; pszSet: LPCSTR): Integer; stdcall; external shlwapidll name 'StrSpnA';

function StrStrA(lpFirst: LPCSTR; lpSrch: LPCSTR): LPSTR; stdcall; external shlwapidll name 'StrStrA';
function StrStrW(lpFirst: LPCWSTR; lpSrch: LPCWSTR): LPWSTR; stdcall; external shlwapidll name 'StrStrW';
function StrStr(lpFirst: LPCSTR; lpSrch: LPCSTR): LPSTR; stdcall; external shlwapidll name 'StrStrA';

function StrStrIA(lpFirst: LPCSTR; lpSrch: LPCSTR): LPSTR; stdcall; external shlwapidll name 'StrStrIA';
function StrStrIW(lpFirst: LPCWSTR; lpSrch: LPCWSTR): LPWSTR; stdcall; external shlwapidll name 'StrStrIW';
function StrStrI(lpFirst: LPCSTR; lpSrch: LPCSTR): LPSTR; stdcall; external shlwapidll name 'StrStrIA';

function StrToIntA(lpSrc: LPCSTR): Integer; stdcall; external shlwapidll name 'StrToIntA';
function StrToIntW(lpSrc: LPCWSTR): Integer; stdcall; external shlwapidll name 'StrToIntW';
function StrToInt(lpSrc: LPCSTR): Integer; stdcall; external shlwapidll name 'StrToIntA';

function StrToIntExA(pszString: LPCSTR; dwFlags: DWORD; out piRet: Integer): BOOL; stdcall; external shlwapidll name 'StrToIntExA';
function StrToIntExW(pszString: LPCWSTR; dwFlags: DWORD; out piRet: Integer): BOOL; stdcall; external shlwapidll name 'StrToIntExW';
function StrToIntEx(pszString: LPCSTR; dwFlags: DWORD; out piRet: Integer): BOOL; stdcall; external shlwapidll name 'StrToIntExA';

{ $if (_WIN32_IE >= 0x0600)}

function StrToInt64ExA(pszString: LPCSTR; dwFlags: DWORD; out pllRet: LONGLONG): BOOL; stdcall; external shlwapidll name 'StrToInt64ExA';
function StrToInt64ExW(pszString: LPCWSTR; dwFlags: DWORD; out pllRet: LONGLONG): BOOL; stdcall; external shlwapidll name 'StrToInt64ExW';
function StrToInt64Ex(pszString: LPCSTR; dwFlags: DWORD; out pllRet: LONGLONG): BOOL; stdcall; external shlwapidll name 'StrToInt64ExA';

{ $endif}

function StrTrimA(psz: LPSTR; pszTrimChars: LPCSTR): BOOL; stdcall; external shlwapidll name 'StrTrimA';
function StrTrimW(psz: LPWSTR; pszTrimChars: LPCWSTR): BOOL; stdcall; external shlwapidll name 'StrTrimW';
function StrTrim(psz: LPSTR; pszTrimChars: LPCSTR): BOOL; stdcall; external shlwapidll name 'StrTrimA';

function StrCatW(psz1: LPWSTR; psz2: LPCWSTR): LPWSTR; stdcall; external shlwapidll name 'StrCatW';
function StrCatA(psz1: LPSTR; psz2: LPCSTR): LPSTR; stdcall; external kernel32 name 'lstrcatA';
function StrCat(psz1: LPSTR; psz2: LPCSTR): LPSTR; stdcall; external kernel32 name 'lstrcatA';

function StrCmpW(psz1: LPCWSTR; psz2: LPCWSTR): Integer; stdcall; external shlwapidll name 'StrCmpW';
function StrCmpA(psz1: LPCSTR; psz2: LPCSTR): Integer; stdcall; external kernel32 name 'lstrcmpA';
function StrCmp(psz1: LPCSTR; psz2: LPCSTR): Integer; stdcall; external kernel32 name 'lstrcmpA';

function StrCmpIW(psz1: LPCWSTR; psz2: LPCWSTR): Integer; stdcall; external shlwapidll name 'StrCmpIW';
function StrCmpIA(psz1: LPCSTR; psz2: LPCSTR): Integer; stdcall; external kernel32 name 'lstrcmpiA';
function StrCmpI(psz1: LPCSTR; psz2: LPCSTR): Integer; stdcall; external kernel32 name 'lstrcmpiA';

function StrCpyW(psz1: LPWSTR; psz2: LPCWSTR): LPWSTR; stdcall; external shlwapidll name 'StrCpyW';
function StrCpyA(psz1: LPSTR; psz2: LPCSTR): LPSTR; stdcall; external kernel32 name 'lstrcpyA';
function StrCpy(psz1: LPSTR; psz2: LPCSTR): LPSTR; stdcall; external kernel32 name 'lstrcpyA';

function StrCpyNW(psz1: LPWSTR; psz2: LPCWSTR; cchMax: Integer): LPWSTR; stdcall; external shlwapidll name 'StrCpyNW';
function StrCpyNA(psz1: LPSTR; psz2: LPCSTR; cchMax: Integer): LPSTR; stdcall; external shlwapidll name 'lstrcpynA';
function StrCpyN(psz1: LPSTR; psz2: LPCSTR; cchMax: Integer): LPSTR; stdcall; external shlwapidll name 'lstrcpynA';

function StrCatBuffW(pszDest: LPWSTR; pszSrc: LPCWSTR; cchDestBuffSize: Integer): LPWSTR; stdcall; external shlwapidll name 'StrCatBuffW';
function StrCatBuffA(pszDest: LPSTR; pszSrc: LPCSTR; cchDestBuffSize: Integer): LPSTR; stdcall; external shlwapidll name 'StrCatBuffA';
function StrCatBuff(pszDest: LPSTR; pszSrc: LPCSTR; cchDestBuffSize: Integer): LPSTR; stdcall; external shlwapidll name 'StrCatBuffA';

function ChrCmpIA(w1: WORD; w2: WORD): BOOL; stdcall; external shlwapidll name 'ChrCmpIA';
function ChrCmpIW(w1: WCHAR; w2: WCHAR): BOOL; stdcall; external shlwapidll name 'ChrCmpIW';
function ChrCmpI(w1: WORD; w2: WORD): BOOL; stdcall; external shlwapidll name 'ChrCmpIA';

function wvnsprintfA(lpOut: LPSTR; cchLimitIn: Integer; lpFmt: LPCSTR; arglist: va_list): Integer; stdcall; external shlwapidll name 'wvnsprintfA';
function wvnsprintfW(lpOut: LPWSTR; cchLimitIn: Integer; lpFmt: LPCWSTR; arglist: va_list): Integer; stdcall; external shlwapidll name 'wvnsprintfW';
function wvnsprintf(lpOut: LPSTR; cchLimitIn: Integer; lpFmt: LPCSTR; arglist: va_list): Integer; stdcall; external shlwapidll name 'wvnsprintfA';

{$IFDEF VER150}
function wnsprintfA(lpOut: LPSTR; cchLimitIn: Integer; lpFmt: LPCSTR): Integer; cdecl; varargs; external shlwapidll name 'wnsprintfA';
function wnsprintfW(lpOut: LPWSTR; cchLimitIn: Integer; lpFmt: LPCWSTR): Integer; cdecl; varargs; external shlwapidll name 'wnsprintfW';
function wnsprintf(lpOut: LPSTR; cchLimitIn: Integer; lpFmt: LPCSTR): Integer; cdecl; varargs; external shlwapidll name 'wnsprintfA';
{$ENDIF}

  { helper to duplicate a string using the task allocator }
function SHStrDupA(psz: LPCSTR; out ppwsz: PWCHAR): HRESULT; stdcall; external shlwapidll name 'SHStrDupA';
function SHStrDupW(psz: LPCWSTR; out ppwsz: PWCHAR): HRESULT; stdcall; external shlwapidll name 'SHStrDupW';
function SHStrDup(psz: LPCSTR; out ppwsz: PWCHAR): HRESULT; stdcall; external shlwapidll name 'SHStrDupA';

function StrCmpLogicalW(psz1: LPCWSTR; psz2: LPCWSTR): Integer; stdcall; external shlwapidll name 'StrCmpLogicalW';

function StrCatChainW(pszDst: LPWSTR; cchDst: DWORD; ichAt: DWORD; pszSrc: LPCWSTR): DWORD; stdcall; external shlwapidll name 'StrCatChainW';

function SHLoadIndirectString(pszSource: LPCWSTR; pszOutBuf: LPWSTR; cchOutBuf: UINT; ppvReserved: PPointer): HRESULT; stdcall; external shlwapidll name 'SHLoadIndirectString';

  { Backward compatible to NT's non-standard naming (strictly
    for comctl32) }

function IntlStrEqWorkerA(fCaseSens: BOOL; lpString1: LPCSTR; lpString2: LPCSTR; nChar: Integer): BOOL; stdcall; external shlwapidll name 'IntlStrEqWorkerA';
function IntlStrEqWorkerW(fCaseSens: BOOL; lpString1: LPCWSTR; lpString2: LPCWSTR; nChar: Integer): BOOL; stdcall; external shlwapidll name 'IntlStrEqWorkerW';
function IntlStrEqWorker(fCaseSens: BOOL; lpString1: LPCSTR; lpString2: LPCSTR; nChar: Integer): BOOL; stdcall; external shlwapidll name 'IntlStrEqWorkerA';

const
  SZ_CONTENTTYPE_HTML = 'text/html';
  SZ_CONTENTTYPE_CDF = 'application/x-cdf';

function PathIsHTMLFileA(pszPath: LPCSTR): BOOL;
function PathIsHTMLFileW(pszPath: LPCWSTR): BOOL;
function PathIsHTMLFile(pszPath: LPCSTR): BOOL;

  { Flags for StrToIntEx }
const
  STIF_DEFAULT = $00000000;
  STIF_SUPPORT_HEX = $00000001;

  { =============== Path Routines =================================== }

function PathAddBackslashA(pszPath: LPSTR): LPSTR; stdcall; external shlwapidll name 'PathAddBackslashA';
function PathAddBackslashW(pszPath: LPWSTR): LPWSTR; stdcall; external shlwapidll name 'PathAddBackslashW';
function PathAddBackslash(pszPath: LPSTR): LPSTR; stdcall; external shlwapidll name 'PathAddBackslashA';

function PathAddExtensionA(pszPath: LPSTR; pszExt: LPCSTR): BOOL; stdcall; external shlwapidll name 'PathAddExtensionA';
function PathAddExtensionW(pszPath: LPWSTR; pszExt: LPCWSTR): BOOL; stdcall; external shlwapidll name 'PathAddExtensionW';
function PathAddExtension(pszPath: LPSTR; pszExt: LPCSTR): BOOL; stdcall; external shlwapidll name 'PathAddExtensionA';

function PathAppendA(pszPath: LPSTR; pMore: LPCSTR): BOOL; stdcall; external shlwapidll name 'PathAppendA';
function PathAppendW(pszPath: LPWSTR; pMore: LPCWSTR): BOOL; stdcall; external shlwapidll name 'PathAppendW';
function PathAppend(pszPath: LPSTR; pMore: LPCSTR): BOOL; stdcall; external shlwapidll name 'PathAppendA';

function PathBuildRootA(pszRoot: LPSTR; iDrive: Integer): LPSTR; stdcall; external shlwapidll name 'PathBuildRootA';
function PathBuildRootW(pszRoot: LPWSTR; iDrive: Integer): LPWSTR; stdcall; external shlwapidll name 'PathBuildRootW';
function PathBuildRoot(pszRoot: LPSTR; iDrive: Integer): LPSTR; stdcall; external shlwapidll name 'PathBuildRootA';

function PathCanonicalizeA(pszBuf: LPSTR; pszPath: LPCSTR): BOOL; stdcall; external shlwapidll name 'PathCanonicalizeA';
function PathCanonicalizeW(pszBuf: LPWSTR; pszPath: LPCWSTR): BOOL; stdcall; external shlwapidll name 'PathCanonicalizeW';
function PathCanonicalize(pszBuf: LPSTR; pszPath: LPCSTR): BOOL; stdcall; external shlwapidll name 'PathCanonicalizeA';

function PathCombineA(pszDest: LPSTR; pszDir: LPCSTR; pszFile: LPCSTR): LPSTR; stdcall; external shlwapidll name 'PathCombineA';
function PathCombineW(pszDest: LPWSTR; pszDir: LPCWSTR; pszFile: LPCWSTR): LPWSTR; stdcall; external shlwapidll name 'PathCombineW';
function PathCombine(pszDest: LPSTR; pszDir: LPCSTR; pszFile: LPCSTR): LPSTR; stdcall; external shlwapidll name 'PathCombineA';

function PathCompactPathA(hDC: HDC; pszPath: LPSTR; dx: UINT): BOOL; stdcall; external shlwapidll name 'PathCompactPathA';
function PathCompactPathW(hDC: HDC; pszPath: LPWSTR; dx: UINT): BOOL; stdcall; external shlwapidll name 'PathCompactPathW';
function PathCompactPath(hDC: HDC; pszPath: LPSTR; dx: UINT): BOOL; stdcall; external shlwapidll name 'PathCompactPathA';

function PathCompactPathExA(pszOut: LPSTR; pszSrc: LPCSTR; cchMax: UINT; dwFlags: DWORD): BOOL; stdcall; external shlwapidll name 'PathCompactPathExA';
function PathCompactPathExW(pszOut: LPWSTR; pszSrc: LPCWSTR; cchMax: UINT; dwFlags: DWORD): BOOL; stdcall; external shlwapidll name 'PathCompactPathExW';
function PathCompactPathEx(pszOut: LPSTR; pszSrc: LPCSTR; cchMax: UINT; dwFlags: DWORD): BOOL; stdcall; external shlwapidll name 'PathCompactPathExA';

function PathCommonPrefixA(pszFile1: LPCSTR; pszFile2: LPCSTR; achPath: LPSTR): Integer; stdcall; external shlwapidll name 'PathCommonPrefixA';
function PathCommonPrefixW(pszFile1: LPCWSTR; pszFile2: LPCWSTR; achPath: LPWSTR): Integer; stdcall; external shlwapidll name 'PathCommonPrefixW';
function PathCommonPrefix(pszFile1: LPCSTR; pszFile2: LPCSTR; achPath: LPSTR): Integer; stdcall; external shlwapidll name 'PathCommonPrefixA';

function PathFileExistsA(pszPath: LPCSTR): BOOL; stdcall; external shlwapidll name 'PathFileExistsA';
function PathFileExistsW(pszPath: LPCWSTR): BOOL; stdcall; external shlwapidll name 'PathFileExistsW';
function PathFileExists(pszPath: LPCSTR): BOOL; stdcall; external shlwapidll name 'PathFileExistsA';

function PathFindExtensionA(pszPath: LPCSTR): LPSTR; stdcall; external shlwapidll name 'PathFindExtensionA';
function PathFindExtensionW(pszPath: LPCWSTR): LPWSTR; stdcall; external shlwapidll name 'PathFindExtensionW';
function PathFindExtension(pszPath: LPCSTR): LPSTR; stdcall; external shlwapidll name 'PathFindExtensionA';

function PathFindFileNameA(pszPath: LPCSTR): LPSTR; stdcall; external shlwapidll name 'PathFindFileNameA';
function PathFindFileNameW(pszPath: LPCWSTR): LPWSTR; stdcall; external shlwapidll name 'PathFindFileNameW';
function PathFindFileName(pszPath: LPCSTR): LPSTR; stdcall; external shlwapidll name 'PathFindFileNameA';

function PathFindNextComponentA(pszPath: LPCSTR): LPSTR; stdcall; external shlwapidll name 'PathFindNextComponentA';
function PathFindNextComponentW(pszPath: LPCWSTR): LPWSTR; stdcall; external shlwapidll name 'PathFindNextComponentW';
function PathFindNextComponent(pszPath: LPCSTR): LPSTR; stdcall; external shlwapidll name 'PathFindNextComponentA';

function PathFindOnPathA(pszPath: LPSTR; ppszOtherDirs: PPAnsiChar): BOOL; stdcall; external shlwapidll name 'PathFindOnPathA';
function PathFindOnPathW(pszPath: LPWSTR; ppszOtherDirs: PPWideChar): BOOL; stdcall; external shlwapidll name 'PathFindOnPathW';
function PathFindOnPath(pszPath: LPSTR; ppszOtherDirs: PPAnsiChar): BOOL; stdcall; external shlwapidll name 'PathFindOnPathA';

function PathGetArgsA(pszPath: LPCSTR): LPSTR; stdcall; external shlwapidll name 'PathGetArgsA';
function PathGetArgsW(pszPath: LPCWSTR): LPWSTR; stdcall; external shlwapidll name 'PathGetArgsW';
function PathGetArgs(pszPath: LPCSTR): LPSTR; stdcall; external shlwapidll name 'PathGetArgsA';

function PathFindSuffixArrayA(pszPath: LPCSTR; apszSuffix: PPAnsiChar; iArraySize: Integer): LPCSTR; stdcall; external shlwapidll name 'PathFindSuffixArrayA';
function PathFindSuffixArrayW(pszPath: LPCWSTR; apszSuffix: PPWideChar; iArraySize: Integer): LPCWSTR; stdcall; external shlwapidll name 'PathFindSuffixArrayW';
function PathFindSuffixArray(pszPath: LPCSTR; apszSuffix: PPAnsiChar; iArraySize: Integer): LPCSTR; stdcall; external shlwapidll name 'PathFindSuffixArrayA';

function PathIsLFNFileSpecA(lpName: LPCSTR): BOOL; stdcall; external shlwapidll name 'PathIsLFNFileSpecA';
function PathIsLFNFileSpecW(lpName: LPCWSTR): BOOL; stdcall; external shlwapidll name 'PathIsLFNFileSpecW';
function PathIsLFNFileSpec(lpName: LPCSTR): BOOL; stdcall; external shlwapidll name 'PathIsLFNFileSpecA';

function PathGetCharTypeA(ch: UCHAR): UINT; stdcall; external shlwapidll name 'PathGetCharTypeA';
function PathGetCharTypeW(ch: WCHAR): UINT; stdcall; external shlwapidll name 'PathGetCharTypeW';

  { Return flags for PathGetCharType }
const
  GCT_INVALID = $0000;
  GCT_LFNCHAR = $0001;
  GCT_SHORTCHAR = $0002;
  GCT_WILD = $0004;
  GCT_SEPARATOR = $0008;

function PathGetDriveNumberA(pszPath: LPCSTR): Integer; stdcall; external shlwapidll name 'PathGetDriveNumberA';
function PathGetDriveNumberW(pszPath: LPCWSTR): Integer; stdcall; external shlwapidll name 'PathGetDriveNumberW';
function PathGetDriveNumber(pszPath: LPCSTR): Integer; stdcall; external shlwapidll name 'PathGetDriveNumberA';

function PathIsDirectoryA(pszPath: LPCSTR): BOOL; stdcall; external shlwapidll name 'PathIsDirectoryA';
function PathIsDirectoryW(pszPath: LPCWSTR): BOOL; stdcall; external shlwapidll name 'PathIsDirectoryW';
function PathIsDirectory(pszPath: LPCSTR): BOOL; stdcall; external shlwapidll name 'PathIsDirectoryA';

function PathIsDirectoryEmptyA(pszPath: LPCSTR): BOOL; stdcall; external shlwapidll name 'PathIsDirectoryEmptyA';
function PathIsDirectoryEmptyW(pszPath: LPCWSTR): BOOL; stdcall; external shlwapidll name 'PathIsDirectoryEmptyW';
function PathIsDirectoryEmpty(pszPath: LPCSTR): BOOL; stdcall; external shlwapidll name 'PathIsDirectoryEmptyA';

function PathIsFileSpecA(pszPath: LPCSTR): BOOL; stdcall; external shlwapidll name 'PathIsFileSpecA';
function PathIsFileSpecW(pszPath: LPCWSTR): BOOL; stdcall; external shlwapidll name 'PathIsFileSpecW';
function PathIsFileSpec(pszPath: LPCSTR): BOOL; stdcall; external shlwapidll name 'PathIsFileSpecA';

function PathIsPrefixA(pszPrefix: LPCSTR; pszPath: LPCSTR): BOOL; stdcall; external shlwapidll name 'PathIsPrefixA';
function PathIsPrefixW(pszPrefix: LPCWSTR; pszPath: LPCWSTR): BOOL; stdcall; external shlwapidll name 'PathIsPrefixW';
function PathIsPrefix(pszPrefix: LPCSTR; pszPath: LPCSTR): BOOL; stdcall; external shlwapidll name 'PathIsPrefixA';

function PathIsRelativeA(pszPath: LPCSTR): BOOL; stdcall; external shlwapidll name 'PathIsRelativeA';
function PathIsRelativeW(pszPath: LPCWSTR): BOOL; stdcall; external shlwapidll name 'PathIsRelativeW';
function PathIsRelative(pszPath: LPCSTR): BOOL; stdcall; external shlwapidll name 'PathIsRelativeA';

function PathIsRootA(pszPath: LPCSTR): BOOL; stdcall; external shlwapidll name 'PathIsRootA';
function PathIsRootW(pszPath: LPCWSTR): BOOL; stdcall; external shlwapidll name 'PathIsRootW';
function PathIsRoot(pszPath: LPCSTR): BOOL; stdcall; external shlwapidll name 'PathIsRootA';

function PathIsSameRootA(pszPath1: LPCSTR; pszPath2: LPCSTR): BOOL; stdcall; external shlwapidll name 'PathIsSameRootA';
function PathIsSameRootW(pszPath1: LPCWSTR; pszPath2: LPCWSTR): BOOL; stdcall; external shlwapidll name 'PathIsSameRootW';
function PathIsSameRoot(pszPath1: LPCSTR; pszPath2: LPCSTR): BOOL; stdcall; external shlwapidll name 'PathIsSameRootA';

function PathIsUNCA(pszPath: LPCSTR): BOOL; stdcall; external shlwapidll name 'PathIsUNCA';
function PathIsUNCW(pszPath: LPCWSTR): BOOL; stdcall; external shlwapidll name 'PathIsUNCW';
function PathIsUNC(pszPath: LPCSTR): BOOL; stdcall; external shlwapidll name 'PathIsUNCA';

function PathIsNetworkPathA(pszPath: LPCSTR): BOOL; stdcall; external shlwapidll name 'PathIsNetworkPathA';
function PathIsNetworkPathW(pszPath: LPCWSTR): BOOL; stdcall; external shlwapidll name 'PathIsNetworkPathW';
function PathIsNetworkPath(pszPath: LPCSTR): BOOL; stdcall; external shlwapidll name 'PathIsNetworkPathA';

function PathIsUNCServerA(pszPath: LPCSTR): BOOL; stdcall; external shlwapidll name 'PathIsUNCServerA';
function PathIsUNCServerW(pszPath: LPCWSTR): BOOL; stdcall; external shlwapidll name 'PathIsUNCServerW';
function PathIsUNCServer(pszPath: LPCSTR): BOOL; stdcall; external shlwapidll name 'PathIsUNCServerA';

function PathIsUNCServerShareA(pszPath: LPCSTR): BOOL; stdcall; external shlwapidll name 'PathIsUNCServerShareA';
function PathIsUNCServerShareW(pszPath: LPCWSTR): BOOL; stdcall; external shlwapidll name 'PathIsUNCServerShareW';
function PathIsUNCServerShare(pszPath: LPCSTR): BOOL; stdcall; external shlwapidll name 'PathIsUNCServerShareA';

function PathIsContentTypeA(pszPath: LPCSTR; pszContentType: LPCSTR): BOOL; stdcall; external shlwapidll name 'PathIsContentTypeA';
function PathIsContentTypeW(pszPath: LPCWSTR; pszContentType: LPCWSTR): BOOL; stdcall; external shlwapidll name 'PathIsContentTypeW';
function PathIsContentType(pszPath: LPCSTR; pszContentType: LPCSTR): BOOL; stdcall; external shlwapidll name 'PathIsContentTypeA';

function PathIsURLA(pszPath: LPCSTR): BOOL; stdcall; external shlwapidll name 'PathIsURLA';
function PathIsURLW(pszPath: LPCWSTR): BOOL; stdcall; external shlwapidll name 'PathIsURLW';
function PathIsURL(pszPath: LPCSTR): BOOL; stdcall; external shlwapidll name 'PathIsURLA';

function PathMakePrettyA(pszPath: LPSTR): BOOL; stdcall; external shlwapidll name 'PathMakePrettyA';
function PathMakePrettyW(pszPath: LPWSTR): BOOL; stdcall; external shlwapidll name 'PathMakePrettyW';
function PathMakePretty(pszPath: LPSTR): BOOL; stdcall; external shlwapidll name 'PathMakePrettyA';

function PathMatchSpecA(pszFile: LPCSTR; pszSpec: LPCSTR): BOOL; stdcall; external shlwapidll name 'PathMatchSpecA';
function PathMatchSpecW(pszFile: LPCWSTR; pszSpec: LPCWSTR): BOOL; stdcall; external shlwapidll name 'PathMatchSpecW';
function PathMatchSpec(pszFile: LPCSTR; pszSpec: LPCSTR): BOOL; stdcall; external shlwapidll name 'PathMatchSpecA';

function PathParseIconLocationA(pszIconFile: LPSTR): Integer; stdcall; external shlwapidll name 'PathParseIconLocationA';
function PathParseIconLocationW(pszIconFile: LPWSTR): Integer; stdcall; external shlwapidll name 'PathParseIconLocationW';
function PathParseIconLocation(pszIconFile: LPSTR): Integer; stdcall; external shlwapidll name 'PathParseIconLocationA';

procedure PathQuoteSpacesA(lpsz: LPSTR); stdcall; external shlwapidll name 'PathQuoteSpacesA';
procedure PathQuoteSpacesW(lpsz: LPWSTR); stdcall; external shlwapidll name 'PathQuoteSpacesW';
procedure PathQuoteSpaces(lpsz: LPSTR); stdcall; external shlwapidll name 'PathQuoteSpacesA';

function PathRelativePathToA(pszPath: LPSTR; pszFrom: LPCSTR; dwAttrFrom: DWORD; pszTo: LPCSTR; dwAttrTo: DWORD): BOOL; stdcall; external shlwapidll name 'PathRelativePathToA';
function PathRelativePathToW(pszPath: LPWSTR; pszFrom: LPCWSTR; dwAttrFrom: DWORD; pszTo: LPCWSTR; dwAttrTo: DWORD): BOOL; stdcall; external shlwapidll name 'PathRelativePathToW';
function PathRelativePathTo(pszPath: LPSTR; pszFrom: LPCSTR; dwAttrFrom: DWORD; pszTo: LPCSTR; dwAttrTo: DWORD): BOOL; stdcall; external shlwapidll name 'PathRelativePathToA';

procedure PathRemoveArgsA(pszPath: LPSTR); stdcall; external shlwapidll name 'PathRemoveArgsA';
procedure PathRemoveArgsW(pszPath: LPWSTR); stdcall; external shlwapidll name 'PathRemoveArgsW';
procedure PathRemoveArgs(pszPath: LPSTR); stdcall; external shlwapidll name 'PathRemoveArgsA';

function PathRemoveBackslashA(pszPath: LPSTR): LPSTR; stdcall; external shlwapidll name 'PathRemoveBackslashA';
function PathRemoveBackslashW(pszPath: LPWSTR): LPWSTR; stdcall; external shlwapidll name 'PathRemoveBackslashW';
function PathRemoveBackslash(pszPath: LPSTR): LPSTR; stdcall; external shlwapidll name 'PathRemoveBackslashA';

procedure PathRemoveBlanksA(pszPath: LPSTR); stdcall; external shlwapidll name 'PathRemoveBlanksA';
procedure PathRemoveBlanksW(pszPath: LPWSTR); stdcall; external shlwapidll name 'PathRemoveBlanksW';
procedure PathRemoveBlanks(pszPath: LPSTR); stdcall; external shlwapidll name 'PathRemoveBlanksA';

procedure PathRemoveExtensionA(pszPath: LPSTR); stdcall; external shlwapidll name 'PathRemoveExtensionA';
procedure PathRemoveExtensionW(pszPath: LPWSTR); stdcall; external shlwapidll name 'PathRemoveExtensionW';
procedure PathRemoveExtension(pszPath: LPSTR); stdcall; external shlwapidll name 'PathRemoveExtensionA';

function PathRemoveFileSpecA(pszPath: LPSTR): BOOL; stdcall; external shlwapidll name 'PathRemoveFileSpecA';
function PathRemoveFileSpecW(pszPath: LPWSTR): BOOL; stdcall; external shlwapidll name 'PathRemoveFileSpecW';
function PathRemoveFileSpec(pszPath: LPSTR): BOOL; stdcall; external shlwapidll name 'PathRemoveFileSpecA';

function PathRenameExtensionA(pszPath: LPSTR; pszExt: LPCSTR): BOOL; stdcall; external shlwapidll name 'PathRenameExtensionA';
function PathRenameExtensionW(pszPath: LPWSTR; pszExt: LPCWSTR): BOOL; stdcall; external shlwapidll name 'PathRenameExtensionW';
function PathRenameExtension(pszPath: LPSTR; pszExt: LPCSTR): BOOL; stdcall; external shlwapidll name 'PathRenameExtensionA';

function PathSearchAndQualifyA(pszPath: LPCSTR; pszBuf: LPSTR; cchBuf:UINT): BOOL; stdcall; external shlwapidll name 'PathSearchAndQualifyA';
function PathSearchAndQualifyW(pszPath: LPCWSTR; pszBuf: LPWSTR; cchBuf:UINT): BOOL; stdcall; external shlwapidll name 'PathSearchAndQualifyW';
function PathSearchAndQualify(pszPath: LPCSTR; pszBuf: LPSTR; cchBuf:UINT): BOOL; stdcall; external shlwapidll name 'PathSearchAndQualifyA';

procedure PathSetDlgItemPathA(hDlg: HWND; id: Integer; pszPath: LPCSTR); stdcall; external shlwapidll name 'PathSetDlgItemPathA';
procedure PathSetDlgItemPathW(hDlg: HWND; id: Integer; pszPath: LPCWSTR); stdcall; external shlwapidll name 'PathSetDlgItemPathW';
procedure PathSetDlgItemPath(hDlg: HWND; id: Integer; pszPath: LPCSTR); stdcall; external shlwapidll name 'PathSetDlgItemPathA';

function PathSkipRootA(pszPath: LPCSTR): LPSTR; stdcall; external shlwapidll name 'PathSkipRootA';
function PathSkipRootW(pszPath: LPCWSTR): LPWSTR; stdcall; external shlwapidll name 'PathSkipRootW';
function PathSkipRoot(pszPath: LPCSTR): LPSTR; stdcall; external shlwapidll name 'PathSkipRootA';

procedure PathStripPathA(pszPath: LPSTR); stdcall; external shlwapidll name 'PathStripPathA';
procedure PathStripPathW(pszPath: LPWSTR); stdcall; external shlwapidll name 'PathStripPathW';
procedure PathStripPath(pszPath: LPSTR); stdcall; external shlwapidll name 'PathStripPathA';

function PathStripToRootA(pszPath: LPSTR): BOOL; stdcall; external shlwapidll name 'PathStripToRootA';
function PathStripToRootW(pszPath: LPWSTR): BOOL; stdcall; external shlwapidll name 'PathStripToRootW';
function PathStripToRoot(pszPath: LPSTR): BOOL; stdcall; external shlwapidll name 'PathStripToRootA';

procedure PathUnquoteSpacesA(lpsz: LPSTR); stdcall; external shlwapidll name 'PathUnquoteSpacesA';
procedure PathUnquoteSpacesW(lpsz: LPWSTR); stdcall; external shlwapidll name 'PathUnquoteSpacesW';
procedure PathUnquoteSpaces(lpsz: LPSTR); stdcall; external shlwapidll name 'PathUnquoteSpacesA';

function PathMakeSystemFolderA(pszPath: LPCSTR): BOOL; stdcall; external shlwapidll name 'PathMakeSystemFolderA';
function PathMakeSystemFolderW(pszPath: LPCWSTR): BOOL; stdcall; external shlwapidll name 'PathMakeSystemFolderW';
function PathMakeSystemFolder(pszPath: LPCSTR): BOOL; stdcall; external shlwapidll name 'PathMakeSystemFolderA';

function PathUnmakeSystemFolderA(pszPath: LPCSTR): BOOL; stdcall; external shlwapidll name 'PathUnmakeSystemFolderA';
function PathUnmakeSystemFolderW(pszPath: LPCWSTR): BOOL; stdcall; external shlwapidll name 'PathUnmakeSystemFolderW';
function PathUnmakeSystemFolder(pszPath: LPCSTR): BOOL; stdcall; external shlwapidll name 'PathUnmakeSystemFolderA';

function PathIsSystemFolderA(pszPath: LPCSTR; dwAttrb: DWORD): BOOL; stdcall; external shlwapidll name 'PathIsSystemFolderA';
function PathIsSystemFolderW(pszPath: LPCWSTR; dwAttrb: DWORD): BOOL; stdcall; external shlwapidll name 'PathIsSystemFolderW';
function PathIsSystemFolder(pszPath: LPCSTR; dwAttrb: DWORD): BOOL; stdcall; external shlwapidll name 'PathIsSystemFolderA';

procedure PathUndecorateA(pszPath: LPSTR); stdcall; external shlwapidll name 'PathUndecorateA';
procedure PathUndecorateW(pszPath: LPWSTR); stdcall; external shlwapidll name 'PathUndecorateW';
procedure PathUndecorate(pszPath: LPSTR); stdcall; external shlwapidll name 'PathUndecorateA';

function PathUnExpandEnvStringsA(pszPath: LPCSTR; pszBuf: LPSTR; cchBuf: UINT): BOOL; stdcall; external shlwapidll name 'PathUnExpandEnvStringsA';
function PathUnExpandEnvStringsW(pszPath: LPCWSTR; pszBuf: LPWSTR; cchBuf: UINT): BOOL; stdcall; external shlwapidll name 'PathUnExpandEnvStringsW';
function PathUnExpandEnvStrings(pszPath: LPCSTR; pszBuf: LPSTR; cchBuf: UINT): BOOL; stdcall; external shlwapidll name 'PathUnExpandEnvStringsA';

const
  URL_SCHEME_INVALID = -1;
  URL_SCHEME_UNKNOWN = 0;
  URL_SCHEME_FTP = 1;
  URL_SCHEME_HTTP = 2;
  URL_SCHEME_GOPHER = 3;
  URL_SCHEME_MAILTO = 4;
  URL_SCHEME_NEWS = 5;
  URL_SCHEME_NNTP = 6;
  URL_SCHEME_TELNET = 7;
  URL_SCHEME_WAIS = 8;
  URL_SCHEME_FILE = 9;
  URL_SCHEME_MK = 10;
  URL_SCHEME_HTTPS = 11;
  URL_SCHEME_SHELL = 12;
  URL_SCHEME_SNEWS = 13;
  URL_SCHEME_LOCAL = 14;
  URL_SCHEME_JAVASCRIPT = 15;
  URL_SCHEME_VBSCRIPT = 16;
  URL_SCHEME_ABOUT = 17;
  URL_SCHEME_RES = 18;
  URL_SCHEME_MSSHELLROOTED = 19;
  URL_SCHEME_MSSHELLIDLIST = 20;
  URL_SCHEME_MSHELP = 21;
  URL_SCHEME_MAXVALUE = 22;

  URL_PART_NONE = 0;
  URL_PART_SCHEME = 1;
  URL_PART_HOSTNAME = 2;
  URL_PART_USERNAME = 3;
  URL_PART_PASSWORD = 4;
  URL_PART_PORT = 5;
  URL_PART_QUERY = 6;

type
  TUrlIs = Integer;

const
  URLIS_URL = 0;
  URLIS_OPAQUE = 1;
  URLIS_NOHISTORY = 2;
  URLIS_FILEURL = 3;
  URLIS_APPLIABLE = 4;
  URLIS_DIRECTORY = 5;
  URLIS_HASQUERY = 6;

const
  URL_UNESCAPE = $10000000;
  URL_ESCAPE_UNSAFE = $20000000;
  URL_PLUGGABLE_PROTOCOL = $40000000;
  URL_WININET_COMPATIBILITY = $80000000;
  URL_DONT_ESCAPE_EXTRA_INFO = $02000000;
  URL_DONT_UNESCAPE_EXTRA_INFO = URL_DONT_ESCAPE_EXTRA_INFO;
  URL_BROWSER_MODE = URL_DONT_ESCAPE_EXTRA_INFO;
  URL_ESCAPE_SPACES_ONLY = $04000000;
  URL_DONT_SIMPLIFY = $08000000;
  URL_NO_META = URL_DONT_SIMPLIFY;
  URL_UNESCAPE_INPLACE = $00100000;
  URL_CONVERT_IF_DOSPATH = $00200000;
  URL_UNESCAPE_HIGH_ANSI_ONLY = $00400000;
  { Will escape #'s in paths }
  URL_INTERNAL_PATH = $00800000;
  URL_FILE_USE_PATHURL = $00010000;
  URL_ESCAPE_PERCENT = $00001000;
  { Treat the entire URL param as one URL segment. }
  URL_ESCAPE_SEGMENT_ONLY = $00002000;
  URL_PARTFLAG_KEEPSCHEME = $00000001;
  URL_APPLY_DEFAULT = $00000001;
  URL_APPLY_GUESSSCHEME = $00000002;
  URL_APPLY_GUESSFILE = $00000004;
  URL_APPLY_FORCEAPPLY = $00000008;

function UrlCompareA(psz1: LPCSTR; psz2: LPCSTR; fIgnoreSlash: BOOL): Integer; stdcall; external shlwapidll name 'UrlCompareA';
function UrlCompareW(psz1: LPCWSTR; psz2: LPCWSTR; fIgnoreSlash: BOOL): Integer; stdcall; external shlwapidll name 'UrlCompareW';
function UrlCompare(psz1: LPCSTR; psz2: LPCSTR; fIgnoreSlash: BOOL): Integer; stdcall; external shlwapidll name 'UrlCompareA';

function UrlCombineA(pszBase: LPCSTR; pszRelative: LPCSTR; pszCombined: LPSTR; pcchCombined: LPDWORD; dwFlags:DWORD):HRESULT; stdcall; external shlwapidll name 'UrlCombineA';
function UrlCombineW(pszBase: LPCWSTR; pszRelative: LPCWSTR; pszCombined: LPWSTR; pcchCombined: LPDWORD; dwFlags:DWORD):HRESULT; stdcall; external shlwapidll name 'UrlCombineW';
function UrlCombine(pszBase: LPCSTR; pszRelative: LPCSTR; pszCombined: LPSTR; pcchCombined: LPDWORD; dwFlags:DWORD):HRESULT; stdcall; external shlwapidll name 'UrlCombineA';

function UrlCanonicalizeA(pszUrl: LPCSTR; pszCanonicalized: LPSTR; pcchCanonicalized: LPDWORD; dwFlags:DWORD):HRESULT; stdcall; external shlwapidll name 'UrlCanonicalizeA';
function UrlCanonicalizeW(pszUrl: LPCWSTR; pszCanonicalized: LPWSTR; pcchCanonicalized: LPDWORD; dwFlags:DWORD):HRESULT; stdcall; external shlwapidll name 'UrlCanonicalizeW';
function UrlCanonicalize(pszUrl: LPCSTR; pszCanonicalized: LPSTR; pcchCanonicalized: LPDWORD; dwFlags:DWORD):HRESULT; stdcall; external shlwapidll name 'UrlCanonicalizeA';

function UrlIsOpaqueA(pszURL: LPCSTR): BOOL; stdcall; external shlwapidll name 'UrlIsOpaqueA';
function UrlIsOpaqueW(pszURL: LPCWSTR): BOOL; stdcall; external shlwapidll name 'UrlIsOpaqueW';
function UrlIsOpaque(pszURL: LPCSTR): BOOL; stdcall; external shlwapidll name 'UrlIsOpaqueA';

function UrlIsNoHistoryA(pszURL: LPCSTR): BOOL; stdcall; external shlwapidll name 'UrlIsNoHistoryA';
function UrlIsNoHistoryW(pszURL: LPCWSTR): BOOL; stdcall; external shlwapidll name 'UrlIsNoHistoryW';
function UrlIsNoHistory(pszURL: LPCSTR): BOOL; stdcall; external shlwapidll name 'UrlIsNoHistoryA';

function UrlIsFileUrlA(pszURL: LPCSTR): BOOL;
function UrlIsFileUrlW(pszURL: LPCWSTR): BOOL;
function UrlIsFileUrl(pszURL: LPCSTR): BOOL;

function UrlIsA(pszUrl: LPCSTR; UrlIs: TUrlIs): BOOL; stdcall; external shlwapidll name 'UrlIsA';
function UrlIsW(pszUrl: LPCWSTR; UrlIs: TUrlIs): BOOL; stdcall; external shlwapidll name 'UrlIsW';
function UrlIs(pszUrl: LPCSTR; UrlIs: TUrlIs): BOOL; stdcall; external shlwapidll name 'UrlIsA';

function UrlGetLocationA(psz1: LPCSTR): LPCSTR; stdcall; external shlwapidll name 'UrlGetLocationA';
function UrlGetLocationW(psz1: LPCWSTR): LPCWSTR; stdcall; external shlwapidll name 'UrlGetLocationW';
function UrlGetLocation(psz1: LPCSTR): LPCSTR; stdcall; external shlwapidll name 'UrlGetLocationA';

function UrlUnescapeA(pszUrl: LPSTR; pszUnescaped: LPSTR; var pcchUnescaped: DWORD; dwFlags:DWORD): HRESULT; stdcall; external shlwapidll name 'UrlUnescapeA';
function UrlUnescapeW(pszUrl: LPWSTR; pszUnescaped: LPWSTR; var pcchUnescaped: DWORD; dwFlags:DWORD): HRESULT; stdcall; external shlwapidll name 'UrlUnescapeW';
function UrlUnescape(pszUrl: LPSTR; pszUnescaped: LPSTR; var pcchUnescaped: DWORD; dwFlags:DWORD): HRESULT; stdcall; external shlwapidll name 'UrlUnescapeA';

function UrlEscapeA(pszUrl: LPCSTR; pszEscaped: LPSTR; var pcchEscaped: DWORD; dwFlags:DWORD): HRESULT; stdcall; external shlwapidll name 'UrlEscapeA';
function UrlEscapeW(pszUrl: LPCWSTR; pszEscaped: LPWSTR; var pcchEscaped: DWORD; dwFlags:DWORD): HRESULT; stdcall; external shlwapidll name 'UrlEscapeW';
function UrlEscape(pszUrl: LPCSTR; pszEscaped: LPSTR; var pcchEscaped: DWORD; dwFlags:DWORD): HRESULT; stdcall; external shlwapidll name 'UrlEscapeA';

function UrlCreateFromPathA(pszPath: LPCSTR; pszUrl: LPSTR; var pcchUrl: DWORD; dwFlags:DWORD): HRESULT; stdcall; external shlwapidll name 'UrlCreateFromPathA';
function UrlCreateFromPathW(pszPath: LPCWSTR; pszUrl: LPWSTR; var pcchUrl: DWORD; dwFlags:DWORD): HRESULT; stdcall; external shlwapidll name 'UrlCreateFromPathW';
function UrlCreateFromPath(pszPath: LPCSTR; pszUrl: LPSTR; var pcchUrl: DWORD; dwFlags:DWORD): HRESULT; stdcall; external shlwapidll name 'UrlCreateFromPathA';

function PathCreateFromUrlA(pszUrl: LPCSTR; pszPath: LPSTR; var pcchPath: DWORD; dwFlags:DWORD): HRESULT; stdcall; external shlwapidll name 'PathCreateFromUrlA';
function PathCreateFromUrlW(pszUrl: LPCWSTR; pszPath: LPWSTR; var pcchPath: DWORD; dwFlags:DWORD): HRESULT; stdcall; external shlwapidll name 'PathCreateFromUrlW';
function PathCreateFromUrl(pszUrl: LPCSTR; pszPath: LPSTR; var pcchPath: DWORD; dwFlags:DWORD): HRESULT; stdcall; external shlwapidll name 'PathCreateFromUrlA';

function UrlHashA(pszUrl: LPCSTR; out pbHash: BYTE; cbHash: DWORD): HRESULT; stdcall; external shlwapidll name 'UrlHashA';
function UrlHashW(pszUrl: LPCWSTR; out pbHash: BYTE; cbHash: DWORD): HRESULT; stdcall; external shlwapidll name 'UrlHashW';
function UrlHash(pszUrl: LPCSTR; out pbHash: BYTE; cbHash: DWORD): HRESULT; stdcall; external shlwapidll name 'UrlHashA';

function UrlGetPartW(pszIn: LPCWSTR; pszOut: LPWSTR; var pcchOut: DWORD; dwPart: DWORD; dwFlags: DWORD): HRESULT; stdcall; external shlwapidll name 'UrlGetPartW';
function UrlGetPartA(pszIn: LPCSTR; pszOut: LPSTR; var pcchOut: DWORD; dwPart: DWORD; dwFlags: DWORD): HRESULT; stdcall; external shlwapidll name 'UrlGetPartA';
function UrlGetPart(pszIn: LPCSTR; pszOut: LPSTR; var pcchOut: DWORD; dwPart: DWORD; dwFlags: DWORD): HRESULT; stdcall; external shlwapidll name 'UrlGetPartA';

function UrlApplySchemeA(pszIn: LPCSTR; pszOut: LPSTR; var pcchOut: DWORD; dwFlags:DWORD): HRESULT; stdcall; external shlwapidll name 'UrlApplySchemeA';
function UrlApplySchemeW(pszIn: LPCWSTR; pszOut: LPWSTR; var pcchOut: DWORD; dwFlags:DWORD): HRESULT; stdcall; external shlwapidll name 'UrlApplySchemeW';
function UrlApplyScheme(pszIn: LPCSTR; pszOut: LPSTR; var pcchOut: DWORD; dwFlags:DWORD): HRESULT; stdcall; external shlwapidll name 'UrlApplySchemeA';

function HashData(const pbData: BYTE; cbData: DWORD; out pbHash: BYTE; cbHash: DWORD): HRESULT; stdcall; external shlwapidll name 'HashData';


{  Association APIs }
{  these APIs are to assist in accessing the data in HKCR }
{  getting the Command strings and exe paths }
{  for different verbs and extensions are simplified this way }

const
  ASSOCF_INIT_NOREMAPCLSID           = $00000001;  //  do not remap clsids to progids
  ASSOCF_INIT_BYEXENAME              = $00000002;  //  executable is being passed in
  ASSOCF_OPEN_BYEXENAME              = $00000002;  //  executable is being passed in
  ASSOCF_INIT_DEFAULTTOSTAR          = $00000004;  //  treat "*" as the BaseClass
  ASSOCF_INIT_DEFAULTTOFOLDER        = $00000008;  //  treat "Folder" as the BaseClass
  ASSOCF_NOUSERSETTINGS              = $00000010;  //  dont use HKCU
  ASSOCF_NOTRUNCATE                  = $00000020;  //  dont truncate the return string
  ASSOCF_VERIFY                      = $00000040;  //  verify data is accurate (DISK HITS)
  ASSOCF_REMAPRUNDLL                 = $00000080;  //  actually gets info about rundlls target if applicable
  ASSOCF_NOFIXUPS                    = $00000100;  //  attempt to fix errors if found
  ASSOCF_IGNOREBASECLASS             = $00000200;  //  dont recurse into the baseclass

type
  ASSOCF = DWORD;
  ASSOCSTR = DWORD;
  ASSOCKEY = DWORD;

const
  ASSOCSTR_COMMAND = 1;            //  shell\verb\command string
  ASSOCSTR_EXECUTABLE = 2;         //  the executable part of command string
  ASSOCSTR_FRIENDLYDOCNAME = 3;    //  friendly name of the document type
  ASSOCSTR_FRIENDLYAPPNAME = 4;    //  friendly name of executable
  ASSOCSTR_NOOPEN = 5;             //  noopen value
  ASSOCSTR_SHELLNEWVALUE = 6;      //  query values under the shellnew key
  ASSOCSTR_DDECOMMAND = 7;         //  template for DDE commands
  ASSOCSTR_DDEIFEXEC = 8;          //  DDECOMMAND to use if just create a process
  ASSOCSTR_DDEAPPLICATION = 9;     //  Application name in DDE broadcast
  ASSOCSTR_DDETOPIC = 10;          //  Topic Name in DDE broadcast
  ASSOCSTR_INFOTIP = 11;           //  info tip for an item = ; or list of properties to create info tip from
  ASSOCSTR_QUICKTIP = 12;          //  same as ASSOCSTR_INFOTIP = ; except = ; this list contains only quickly retrievable properties
  ASSOCSTR_TILEINFO = 13;          //  similar to ASSOCSTR_INFOTIP - lists important properties for tileview
  ASSOCSTR_CONTENTTYPE = 14;       //  MIME Content type
  ASSOCSTR_DEFAULTICON = 15;       //  Default icon source
  ASSOCSTR_SHELLEXTENSION = 16;    //  Guid string pointing to the Shellex\Shellextensionhandler value.
  ASSOCSTR_MAX = 17;               //  last item in enum...

  ASSOCKEY_SHELLEXECCLASS = 1;     //  the key that should be passed to ShellExec(hkeyClass)
  ASSOCKEY_APP = 2;                //  the "Application" key for the association
  ASSOCKEY_CLASS = 3;              //  the progid or class key
  ASSOCKEY_BASECLASS = 4;          //  the BaseClass key
  ASSOCKEY_MAX = 5;                //  last item in enum...

  ASSOCDATA_MSIDESCRIPTOR = 1;      //  Component Descriptor to pass to MSI APIs
  ASSOCDATA_NOACTIVATEHANDLER = 2;  //  restrict attempts to activate window
  ASSOCDATA_QUERYCLASSSTORE = 3;    //  should check with the NT Class Store
  ASSOCDATA_HASPERUSERASSOC = 4;    //  defaults to user specified association
  ASSOCDATA_EDITFLAGS = 5;          //  Edit flags.
  ASSOCDATA_VALUE = 6;              //  use pszExtra as the Value name
  ASSOCDATA_MAX = 7;

  ASSOCENUM_NONE = 0;

function AssocCreate(clsid: TGUID; riid: TGUID; out ppv): HRESULT; stdcall; external shlwapidll name 'AssocCreate';

{  wrappers for the interface }
function AssocQueryStringA(flags: ASSOCF; str: ASSOCSTR; pszAssoc: LPCSTR; pszExtra: LPCSTR; pszOut: LPSTR;
  var pcchOut: DWORD): HRESULT; stdcall; external shlwapidll name 'AssocQueryStringA';
function AssocQueryStringW(flags: ASSOCF; str: ASSOCSTR; pszAssoc: LPCWSTR; pszExtra: LPCWSTR; pszOut: LPWSTR;
  var pcchOut: DWORD): HRESULT; stdcall; external shlwapidll name 'AssocQueryStringW';
function AssocQueryString(flags: ASSOCF; str: ASSOCSTR; pszAssoc: LPCSTR; pszExtra: LPCSTR; pszOut: LPSTR;
  var pcchOut: DWORD): HRESULT; stdcall; external shlwapidll name 'AssocQueryStringA';

function AssocQueryStringByKeyA(flags: ASSOCF; str: ASSOCSTR; hkAssoc: HKEY; pszExtra: LPCSTR; pszOut: LPSTR;
  var pcchOut: DWORD): HRESULT; stdcall; external shlwapidll name 'AssocQueryStringByKeyA';
function AssocQueryStringByKeyW(flags: ASSOCF; str: ASSOCSTR; hkAssoc: HKEY; pszExtra: LPCWSTR; pszOut: LPWSTR;
  var pcchOut: DWORD): HRESULT; stdcall; external shlwapidll name 'AssocQueryStringByKeyW';
function AssocQueryStringByKey(flags: ASSOCF; str: ASSOCSTR; hkAssoc: HKEY; pszExtra: LPCSTR; pszOut: LPSTR;
  var pcchOut: DWORD): HRESULT; stdcall; external shlwapidll name 'AssocQueryStringByKeyA';

function AssocQueryKeyA(flags: ASSOCF; key: ASSOCKEY; pszAssoc: LPCSTR; pszExtra: LPCSTR; out phkeyOut: HKEY): HRESULT; stdcall; external shlwapidll name 'AssocQueryKeyA';
function AssocQueryKeyW(flags: ASSOCF; key: ASSOCKEY; pszAssoc: LPCWSTR; pszExtra: LPCWSTR; out phkeyOut: HKEY): HRESULT; stdcall; external shlwapidll name 'AssocQueryKeyW';
function AssocQueryKey(flags: ASSOCF; key: ASSOCKEY; pszAssoc: LPCSTR; pszExtra: LPCSTR; out phkeyOut: HKEY): HRESULT; stdcall; external shlwapidll name 'AssocQueryKeyA';

    {  AssocIsDangerous() checks a file type to determine whether it is "Dangerous" }
    {      this maps to the IE download dialog's forcing a prompt to open or save. }
    {      dangerous file types should be handled more carefully than other file types. }
    { }
    {  Parameter:  pszAssoc - type to check.  may be an extension or progid.  (".exe" or "exefile" would both be valid) }
    { }
    {  Returns: TRUE if the file type is dangerous. }
    { }
    {  NOTES: }
    { }
    {      this API first checks a hardcoded list of known dangerous types. }
    {      then it checks the editflags for the file type looking for the FTA_AlwaysUnsafe bit. }
    {      then it checks Safer policies. }
    {       }
function AssocIsDangerous(pszAssoc: LPCWSTR): BOOL; stdcall; external shlwapidll name 'AssocIsDangerous';

{ =============== Stream Routines =================================== }

function SHCreateStreamOnFileA(pszFile: LPCSTR; grfMode: DWORD; out ppstm: IStream): HRESULT; stdcall; external shlwapidll name 'SHCreateStreamOnFileA';
function SHCreateStreamOnFileW(pszFile: LPCWSTR; grfMode: DWORD; out ppstm: IStream): HRESULT; stdcall; external shlwapidll name 'SHCreateStreamOnFileW';
function SHCreateStreamOnFile(pszFile: LPCSTR; grfMode: DWORD; out ppstm: IStream): HRESULT; stdcall; external shlwapidll name 'SHCreateStreamOnFileA';

function SHCreateStreamOnFileEx(pszFile: LPCWSTR; grfMode: DWORD; dwAttributes: DWORD; fCreate: BOOL; pstmTemplate: IStream;
  out ppstm: IStream): HRESULT; stdcall; external shlwapidll name 'SHCreateStreamOnFileEx';

    { SHAutoComplete }
    {      hwndEdit - HWND of editbox, ComboBox or ComboBoxEx. }
    {      dwFlags - Flags to indicate what to AutoAppend or AutoSuggest for the editbox. }
    { }
    { WARNING: }
    {    Caller needs to have called CoInitialize() or OleInitialize() }
    {    and cannot call CoUninit/OleUninit until after }
    {    WM_DESTROY on hwndEdit. }
    { }
    {  dwFlags values: }
    { Currently (SHACF_FILESYSTEM | SHACF_URLALL) }

const
  SHACF_DEFAULT = $00000000;
  { This includes the File System as well as the rest of the shell (Desktop\My Computer\Control Panel\) }
  SHACF_FILESYSTEM = $00000001;
  { URLs in the User's History }
  SHACF_URLHISTORY = $00000002;
  { URLs in the User's Recently Used list. }
  SHACF_URLMRU = $00000004;
  SHACF_URLALL = SHACF_URLHISTORY or SHACF_URLMRU;
  { Use the tab to move thru the autocomplete possibilities instead of to the next dialog/window control. }
  SHACF_USETAB = $00000008;
  { This includes the File System }
  SHACF_FILESYS_ONLY = $00000010;
{ $if (_WIN32_IE >= 0x0600)}
  { Same as SHACF_FILESYS_ONLY except it only includes directories, UNC servers, and UNC server shares. }
  SHACF_FILESYS_DIRS = $00000020;
{ $endif}
    { (_WIN32_IE >= 0x0600) }
  { Ignore the registry default and force the feature on. }
  SHACF_AUTOSUGGEST_FORCE_ON = $10000000;
  { Ignore the registry default and force the feature off. }
  SHACF_AUTOSUGGEST_FORCE_OFF = $20000000;
  { Ignore the registry default and force the feature on. (Also know as AutoComplete) }
  SHACF_AUTOAPPEND_FORCE_ON = $40000000;
  { Ignore the registry default and force the feature off. (Also know as AutoComplete) }
  SHACF_AUTOAPPEND_FORCE_OFF = $80000000;

function SHAutoComplete(hwndEdit: HWND; dwFlags: DWORD): HRESULT; stdcall; external shlwapidll name 'SHAutoComplete';

{====== GDI helper functions  ================================================ }

procedure ColorRGBToHLS(clrRGB: COLORREF; out pwHue: WORD; out pwLuminance: WORD; out pwSaturation: WORD); stdcall; external shlwapidll name 'ColorRGBToHLS';
function ColorHLSToRGB(wHue: WORD; wLuminance: WORD; wSaturation: WORD): TColor; stdcall; external shlwapidll name 'ColorHLSToRGB';
function ColorAdjustLuma(clrRGB: COLORREF; n: Integer; fScale: BOOL): TColor; stdcall; external shlwapidll name 'ColorAdjustLuma';

{====== DllGetVersion  ======================================================= }

type
  _DLLVERSIONINFO = packed record
    cbSize: DWORD;
    dwMajorVersion: DWORD;
    dwMinorVersion: DWORD;
    dwBuildNumber: DWORD;
    dwPlatformID: DWORD;
  end;
  DLLVERSIONINFO = _DLLVERSIONINFO;
  TDllVersionInfo = DLLVERSIONINFO;
  PDllVersionInfo = ^TDllVersionInfo;
  { Platform IDs for DLLVERSIONINFO }
  { Windows 95 }

const
  DLLVER_PLATFORM_WINDOWS = $00000001;
  { Windows NT }
  DLLVER_PLATFORM_NT = $00000002;
  { No flags currently defined }
  { Encoded as: }
  { Major 0xFFFF 0000 0000 0000 }
  { Minor 0x0000 FFFF 0000 0000 }
  { Build 0x0000 0000 FFFF 0000 }
  { QFE   0x0000 0000 0000 FFFF }

type
  ULONGLONG = Int64;
  
  _DLLVERSIONINFO2 = record
    info1 : DLLVERSIONINFO;
    dwFlags : DWORD;
    ullVersion : ULONGLONG;
  end;
  DLLVERSIONINFO2 = _DLLVERSIONINFO2;
  TDllVersionInfo2 = DLLVERSIONINFO2;
  PDllVersionInfo2 = ^TDllVersionInfo2;

const
  DLLVER_MAJOR_MASK = $FFFF000000000000;
  DLLVER_MINOR_MASK = $0000FFFF00000000;
  DLLVER_BUILD_MASK = $00000000FFFF0000;
  DLLVER_QFE_MASK = $000000000000FFFF;

implementation

function PathIsHTMLFileA(pszPath: LPCSTR): BOOL;
begin
  Result := PathIsContentTypeA(pszPath, SZ_CONTENTTYPE_HTML);
end;

function PathIsHTMLFile(pszPath: LPCSTR): BOOL;
begin
  Result := PathIsContentTypeA(pszPath, SZ_CONTENTTYPE_HTML);
end;

function PathIsHTMLFileW(pszPath: LPCWSTR): BOOL;
begin
  Result := PathIsContentTypeW(pszPath, SZ_CONTENTTYPE_HTML);
end;

function UrlIsFileUrlA(pszURL: LPCSTR): BOOL;
begin
  Result := UrlIsA(pszURL, URLIS_FILEURL);
end;

function UrlIsFileUrl(pszURL: LPCSTR): BOOL;
begin
  Result := UrlIsA(pszURL, URLIS_FILEURL);
end;

function UrlIsFileUrlW(pszURL: LPCWSTR): BOOL;
begin
  Result := UrlIsW(pszURL, URLIS_FILEURL);
end;

end.
